/*
 * Copyright (C) 2013, Intel Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var jWebAudio=function(){window.hasOwnProperty("AudioContext")?this.context=new AudioContext:window.hasOwnProperty("webkitAudioContext")?this.context=new webkitAudioContext:(this.context=null,console.error("Web audio is not supported in current web browser. Please try with the latest Chrome."))},jWebAudio=new jWebAudio;jWebAudio.SoundEngine=function(){this.soundArray=[]};
jWebAudio.SoundEngine.prototype={addSoundSource:function(a){if("object"===typeof a&&a.hasOwnProperty("url")){!0!==a.preLoad&&(a.preLoad=!1);"function"!==typeof a.callback&&"object"!==typeof a.callback&&(a.callback=null);!0!==a.multishot&&(a.multishot=!1);if("string"===typeof a.url)return this.soundArray.push(new jWebAudio.SoundSource(this.soundArray.length,a)),this.soundArray[this.soundArray.length-1];if("object"===typeof a.url){if(a.preLoad){var c=a.url.length,e=0,f=a.callback;a.callback=function(){++e;
e===c&&f&&f()}}var d=this.soundArray.length,g=a.url.slice(),b;for(b in a.url)a.url=g[b],this.soundArray.push(new jWebAudio.SoundSource(this.soundArray.length,a));a=[];for(b=d;b<this.soundArray.length;++b)a[b-d]=this.soundArray[b];return a}}else console.error("Error url in addSoundSource.")},destroySound:function(a){this.soundArray[a]&&(this.soundArray[a].isLoaded&&this.soundArray[a].stop(),delete this.soundArray[a])}};
jWebAudio.SoundSource=function(a,c){this.id=c.id;this.url=c.url;this.multishot=c.multishot;this.isLoaded=!1;this.options=c;this.finish=c.finish;this.sound=null;!0===c.preLoad&&this.load(c.callback)};
jWebAudio.SoundSource.prototype.load=function(a){if(!this.isLoaded){var c=new XMLHttpRequest;c.open("GET",this.url,!0);c.responseType="arraybuffer";var e=this;c.onload=function(){jWebAudio.context.decodeAudioData(c.response,function(c){e.sound=e.multishot?new jWebAudio.WebAudioMultishotSound(c):new jWebAudio.WebAudioSound(c,e.finish);e.sound.options=e.options;e.isLoaded=!0;a&&a();return!0},function(){console.error("Cannot decode: "+e.url);return!1})};c.onerror=function(){console.error("Load error")};
c.send()}};jWebAudio.extend=function(a,c){var e=function(){};e.prototype=c.prototype;a.prototype=new e;a.prototype.constructor=a};jWebAudio.leftMerge=function(a,c){for(var e in c)a.hasOwnProperty(e)&&("object"===typeof a[e]?"object"===typeof c[e]&&leftMerge(a[e],c[e]):a[e]=c[e])};
jWebAudio.Sound=function(){this.STOPPED=0;this.PLAYING=1;this.PAUSED=2;var a=this,c={loop:!1,loopGap:0,muted:!1,volume:100,fadeIn:!1,fadeOut:!1,fadeInTime:3,fadeOutTime:3};this.getOptions=function(){return c};this.__defineGetter__("options",this.getOptions);this.setOptions=function(b){b&&("boolean"===typeof b.muted&&b.muted!==c.muted&&a.setMuted(b.muted),"number"===typeof b.volume&&b.volume!==c.volume&&a.setVolume(b.volume),"boolean"===typeof b.fadeIn&&(c.fadeIn=b.fadeIn,a.setFadeIn(c.fadeIn,b.fadeInTime)),
"boolean"===typeof b.fadeOut&&(c.fadeOut=b.fadeOut,a.setFadeOut(c.fadeOut,b.fadeOutTime)),jWebAudio.leftMerge(c,b))};this.__defineSetter__("options",this.setOptions);this.setMuted=function(b){"boolean"!==typeof b?console.error("Error type of mute!"):(c.muted=b,f.gain.value=b?0:c.volume/100)};this.getMuted=function(b){return a.options.muted};this.setVolume=function(b){b=+b;isNaN(b)?console.error("Error type of volume in setVolume"):(c.volume=b,f.gain.value=b/100)};this.getVolume=function(){return a.options.volume};
this.getLoop=function(){return a.options.loop};var e=jWebAudio.context,f=e.createGainNode();this.__defineGetter__("gain",function(){return f});var d=[],g=[];this.addEffect=function(b){"string"===typeof b&&(b=new jWebAudio.Effect(b));if(b instanceof jWebAudio.Effect){var a;a:{for(a=0;a<d.length;++a)if(void 0!==d[a]){a=d[a];break a}a=null}var c;a:{for(c=d.length-1;0<=c;--c)if(void 0!==d[c]){c=d[c];break a}c=null}null!==a?(c.outNode.disconnect(),c.outNode.connect(b.inNode)):(f.disconnect(),f.connect(b.inNode));
b.outNode.connect(e.destination);d.push(b);g.push(b.getName());return d.length-1}console.error("Error in addEffect: effect is not instance of Effect")};this.getEffectNames=function(){return g};this.getEffect=function(b){return d[b]};this.deleteEffect=function(b){if(void 0!==d[b]){for(var a=null,c=b-1;0<=c;--c)if(void 0!==d[c]){a=d[c].outNode;break}for(var h=e.destination,c=b+1;c<d.length;++c)if(void 0!==d[c]){h=d[c].inNode;break}null===a?(f.disconnect(),f.connect(h)):(a.disconnect(),a.connect(h));
delete d[b];delete g[b]}};this.clearAllEffects=function(){for(var a=d.length-1;0<=a;--a)if(void 0!==d[a]){f.disconnect();d[a].outNode.disconnect();f.connect(e.destination);d=[];g=[];break}};f.connect(e.destination)};
jWebAudio.WebAudioSound=function(a,c){function e(){var a=m.duration-h;l=g.createBufferSource();l.buffer=m;l.loop=d.options.loop;l.connect(b);d.options.fadeIn&&(b.gain.setValueAtTime(b.gain.minValue,g.currentTime),b.gain.linearRampToValueAtTime(b.gain.maxValue,g.currentTime+d.options.fadeInTime));l.noteGrainOn(0,h,a);n=g.currentTime;k=d.PLAYING;p=function(){return setTimeout(function(){!0===d.options.loop?(d.seek(0),d.options.loopGap&&0<d.options.loopGap&&(d.stop(),loopGapEvent=setTimeout(function(){e()},
1E3*d.options.loopGap))):(h=0,k=d.STOPPED);c&&c()},1E3*a)}();!0===d.options.fadeOut&&(q=function(){return setTimeout(function(){b.gain.setValueAtTime(b.gain.maxValue,g.currentTime);b.gain.linearRampToValueAtTime(b.gain.minValue,g.currentTime+d.options.fadeOutTime)},1E3*(a-d.options.fadeOutTime))}())}function f(){k===d.PLAYING&&(l.noteOff(0),l=null,h+=g.currentTime-n,clearTimeout(p),clearTimeout(q))}jWebAudio.Sound.call(this);var d=this,g=jWebAudio.context,b=g.createGainNode();b.connect(d.gain);var l=
null,m=a;this.__defineGetter__("duration",function(){return m.duration});var h=0;this.__defineGetter__("offset",function(){return k===d.PLAYING?g.currentTime-n+h:h});this.seek=function(a){if("number"!==typeof a||0>a||a>m.duration)console.error("Error arg in WebAudioSound.");else{var b=k;f();h=a;b===this.PLAYING&&e()}};var n=0,k=this.STOPPED;this.__defineGetter__("state",function(){return k});var p=null,q=null;this.play=function(){k!==d.PLAYING&&e()};this.pause=function(){k===d.PLAYING&&(f(),k=d.PAUSED)};
this.stop=function(){if(k!==d.STOPPED)if(d.options.fadeOut){var a=d.options.fadeOutTime;b.gain.linearRampToValueAtTime(b.gain.minValue,g.currentTime+a);setTimeout(function(){f();h=0;k=d.STOPPED},1E3*a)}else f(),h=0,k=d.STOPPED};this.setFadeIn=function(a,b){"boolean"===typeof a?(d.options.fadeIn=a,"number"===typeof b&&(d.options.fadeInTime=b)):(d.options.fadeOut=ifFadeOut,console.error("Error type in setFadeIn."))};this.setFadeOut=function(a,b){"boolean"===typeof a&&"number"===typeof b&&(d.options.fadeOutTime=
b)}};jWebAudio.extend(jWebAudio.WebAudioSound,jWebAudio.Sound);jWebAudio.WebAudioMultishotSound=function(a){jWebAudio.Sound.call(this);var c=jWebAudio.context,e=[],f=this;this.play=function(){var d=c.createBufferSource();d.buffer=a;d.loop=this.loop;d.connect(f.gain);d.noteOn(0);e.push(d)};this.stop=function(){e.forEach(function(a){a.noteOff(0);a.disconnect()});e=[]}};jWebAudio.extend(jWebAudio.WebAudioMultishotSound,jWebAudio.Sound);
jWebAudio.Effect=function(a){if("telephonize"===a)return new jWebAudio.Filter(a,[{type:jWebAudio.Filter.prototype.LOWPASS,frequency:2E3},{type:jWebAudio.Filter.prototype.HIGHPASS,frequency:500}]);if("cathedral"===a)return new jWebAudio.Filter(a,[{type:jWebAudio.Filter.prototype.BANDPASS,frequency:3E3},{type:jWebAudio.Filter.prototype.ALLPASS,frequency:1E3}]);if("3d"===a)return new jWebAudio.Spatiality;console.error('Effect name: "'+a+'" not found')};
jWebAudio.Filter=function(a,c){this.getName=function(){return a};var e,f;f=[];var d,g,b=[];if(c instanceof Array)f=c;else if(c instanceof Object)f.push(c);else return;var l=jWebAudio.context;for(e=0;e<f.length;++e)d=f[e],0<=d.type&&7>=d.type&&(g=l.createBiquadFilter(),g.type=d.type,g.frequency.value=d.frequency,g.Q.value=d.Q,g.gain.value=d.gain,b.push(g));for(e=0;e<b.length-1;++e)f=e+1,b[e].connect(b[f]);this.__defineGetter__("inNode",function(){return b[0]});this.__defineGetter__("outNode",function(){return b[b.length-
1]})};jWebAudio.extend(jWebAudio.Filter,jWebAudio.Effect);jWebAudio.Filter.prototype.LOWPASS=0;jWebAudio.Filter.prototype.HIGHPASS=1;jWebAudio.Filter.prototype.BANDPASS=2;jWebAudio.Filter.prototype.LOWSHELF=3;jWebAudio.Filter.prototype.HIGHSHELF=4;jWebAudio.Filter.prototype.PEAKING=5;jWebAudio.Filter.prototype.NOTCH=6;jWebAudio.Filter.prototype.ALLPASS=7;
jWebAudio.Spatiality=function(){this.soundObject=jWebAudio.context.createPanner();var a=this;this.__defineGetter__("inNode",function(){return a.soundObject});this.__defineGetter__("outNode",function(){return a.soundObject})};jWebAudio.extend(jWebAudio.Spatiality,jWebAudio.Effect);jWebAudio.Spatiality.prototype.getName=function(){return"3d"};
